-- EnvenomX Core.lua by break19
-- The following if/then statement disables the addon, and exits early, preventing it from loading,
-- But only if the character is not a rogue.
if (select(2, UnitClass("player"))) ~= "ROGUE" then
	DisableAddOn("EnvenomX")
	return
end

local _G = getfenv(0)
local vx = LibStub("AceAddon-3.0"):NewAddon("EnvenomX", "AceEvent-3.0", "AceBucket-3.0", "AceTimer-3.0", "AceConsole-3.0")
local sink = LibStub("Sink-1.0")
local L = LibStub("AceLocale-3.0"):GetLocale("EnvenomX", true)
local reg = LibStub("AceConfigRegistry-3.0")
local dialog = LibStub("AceConfigDialog-3.0")
local spellname = L["Deadly Poison"]
local options = {}

local defaults = {
	profile = {
		r = 1,
		g = 1,
		b = 0,
		font = "GameFontNormal",
		size = 26,
		outline = "ThickOutline",
		loc = "Notification",
		text = L["Envenom!!"],
		stickytext = "true",
		sinkicon = "\\Interface\\Icons\\Trade_BrewPoison"
	}
}
local bucketlist = {
	"PLAYER_COMBO_POINTS",
	"UNIT_AURA",
	"PLAYER_TARGET_CHANGED"
}
options = {
	type = "group",
	name = "EnvenomX",
	order = 1,
	args = {
		Text = {
			order = 1,
			type = "input",
			name = L["Output Text"],
			desc = L["What to say when EnvenomX fires (default: Envenom!!)"],
			set = function(k,v) vx.db.profile.text = v; end,
		},
	},
}

function vx:OnInitialize()
	reg:RegisterOptionsTable("EnvenomX", options)
	self:RegisterChatCommand("envenomx", function() dialog:Open("EnvenomX") end)
	self:RegisterChatCommand("evx", function() dialog:Open("EnvenomX") end)
	vx.db = LibStub("AceDB-3.0"):New("EnvenomXDB", defaults)
end

function vx:OnEnable()
	self:RegisterEvent("PLAYER_REGEN_DISABLED","CombatEnter")
	self:RegisterEvent("PLAYER_REGEN_ENABLED","CombatLeave")
end

function vx:onDisable()
	self:UnregisterEvent("CombatEnter")
	self:UnregisterEvent("CombatLeave")
end

function vx:CombatEnter()
	self:RegisterBucketEvent(bucketlist, 2.0, "CheckEnvenom")
end

function vx:CombatLeave()
	self:UnregisterBucket("CheckEnvenom")
end

function vx:CountPoisons()
	for index=1,40,1 do
		local name, rank, texture, count, debuffType, duration, timeLeft  =  UnitDebuff("target", index)
		if duration and string.find( name, spellname ) then
			return count
		end
	end
	return 0
end	

function vx:CheckEnvenom()
	local cp = _G.GetComboPoints()
	local dp = vx:CountPoisons()
	if cp==5 and dp==5 then
		sink:Pour(vx.db.profile.text, vx.db.profile.r, vx.db.profile.g, vx.db.profile.b, vx.db.profile.font, vx.db.profile.size, vx.db.profile.outline, vx.db.profile.stickytext, vx.db.profile.loc, vx.db.profile.sinkicon)
	end
end